import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { AppField, AppFieldParam } from '@/api/oa/app/field/model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询项目参数
 */
export async function pageAppField(params: AppFieldParam) {
  const res = await request.get<ApiResult<PageResult<AppField>>>(
    MODULES_API_URL + '/oa/app-field/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询项目参数列表
 */
export async function listAppField(params?: AppFieldParam) {
  const res = await request.get<ApiResult<AppField[]>>(
    MODULES_API_URL + '/oa/app-field',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询项目参数
 */
export async function getAppField(id: number) {
  const res = await request.get<ApiResult<AppField>>(
    MODULES_API_URL + '/oa/app-field/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加项目参数
 */
export async function addAppField(data: AppField) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/app-field',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改项目参数
 */
export async function updateAppField(data: AppField) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/app-field',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除项目参数
 */
export async function removeAppField(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/app-field/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除项目参数
 */
export async function removeBatchAppField(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/app-field/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/app-field/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
